<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelVendaFiscalGerencialServices;
use Teknisa\MAN\Utilities\Util;

class RelVendaFiscalGerencial {
    protected $dataSourceName = 'vnd10001_relvendafiscalgerencial';
    protected $fiscalService;
    protected $utilService;
    
    public function __construct (RelVendaFiscalGerencialServices $fiscalService, Util $utilService ){
        $this->utilService = $utilService;
        $this->fiscalService = $fiscalService;
    }
    
    public function getFiscalGerencial(Request\Filter $request, Response $response) {
        
        try {
            $conditions = $this->utilService->getParamsAsArray($request);
            
            if(!array_key_exists('CDFILIAL', $conditions)) {
                $conditions['CDFILIAL'] = array();
            }
            
            if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['P_DTINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['P_DTFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
            }
        
        if ((array_key_exists('CDFILIAL', $conditions) && (array_key_exists('P_DTINI', $conditions) && (array_key_exists('P_DTFIN', $conditions)))))    
            $response->addDataSet(new DataSet("vnd10001_relvendafiscalgerencial", 
                $this->fiscalService->buscaFiscalGerencial($conditions['CDFILIAL'],$conditions['P_DTINI'], $conditions["P_DTFIN"])));
            return $response;
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}