<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class DayPartService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function buscaDayPart($conditions) {
	    $FILIAL     = join("_", $conditions['CDFILIAL']);
        $DTINICIO   = $conditions['DTPERIODO'][0];
        $DTFIM      = $conditions['DTPERIODO'][1];
        $NRORG      = $conditions['NRORG'];
        $parameters = array(
            'DTINI'    => $DTINICIO,
            'DTFIN'    => $DTFIM,
            'CDFILIAL' => $FILIAL,
            'NRORG'    => $NRORG
        );
        $params = array(
            'DATAINI'    => $DTINICIO,
            'DATAFIN'    => $DTFIM,
            'CDFILIAL'   => $FILIAL,
            'NRORG'      => $NRORG
        );
	    $return = $this->entityManager->getConnection()->fetchAll(self::DAY_PART, $parameters);
	    $totalVendas = 0;
	    for($i = 0; $i < count($return); $i++){
	      $totalVendas += $return[$i]['VRVENDAS'];
	    }
	    $totalvnd;
	    foreach($return as &$byFilial){
	        $params['CDFILIAL']         = $byFilial['CDFILIAL'];
	        $totalvnd = $this->entityManager->getConnection()->fetchAssoc(self::GET_VALOR_TOTAL, $params);
	        $byFilial['TOTALVND'] = isset($totalvnd["VALOR_TOTAL"]) ? $totalvnd["VALOR_TOTAL"] : null;
	        $byFilial['TICKETMEDIO']    = $byFilial['VRVENDAS'] / $byFilial['NRCUPONS'];
	        $byFilial['ITENSPORTICKET'] = $byFilial['QTDE'] / $byFilial['NRCUPONS'];
	        $byFilial['PCTPERIODO']     = ($byFilial['VRVENDAS'] * 100) / $totalVendas;
          $byFilial['PERIODO']        =  $byFilial['PERIODO'].' - '.$byFilial['HRINI1DAYPART'].' às '.$byFilial['HRFIN1DAYPART'];
	        $byFilial['FATURAMENTO']    = $byFilial['TOTALVND'] + $byFilial['VALOR_VENDIDO'] + $byFilial['VRDESCONTO'];
	    }
	    return $return;
	}
	
	const DAY_PART = "SELECT V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI1DAYPART,
                      P.HRFIN1DAYPART,
                      COUNT(DISTINCT V.CDFILIAL
                      || V.CDCAIXA
                      || V.NRSEQVENDA)                                                                                                                 AS NRCUPONS,
                      SUM(I.QTPRODVEND)                                                                                                                AS QTDE,
                      SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0) ), 2) - NVL (I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRVENDAS,
                      SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0))                                      AS VALOR_VENDIDO,
                      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                      '1'                                                                                                                              AS PERIODO,
                      V.NRORG
                    FROM VENDA V
                    JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                    AND V.NRORG     = I.NRORG
                    AND V.CDFILIAL  = I.CDFILIAL
                    AND V.CDCAIXA   = I.CDCAIXA
                    JOIN PARAVEND P
                    ON V.CDFILIAL = P.CDFILIAL
                    AND V.NRORG   = P.NRORG
                    JOIN FILIAL F
                    ON V.CDFILIAL       = F.CDFILIAL
                    AND V.NRORG         = F.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.NRORG         = :NRORG
                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                    AND INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                    AND ( TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(P.HRINI1DAYPART, 'HH24:MI:SS' ) AND TO_DATE(P.HRFIN1DAYPART, 'HH24:MI:SS' ) )
                    GROUP BY V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI1DAYPART,
                      P.HRFIN1DAYPART,
                      V.NRORG
                    UNION ALL
                    SELECT V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI2DAYPART,
                      P.HRFIN2DAYPART,
                      COUNT(DISTINCT V.CDFILIAL
                      || V.CDCAIXA
                      || V.NRSEQVENDA)                                                                                                                 AS NRCUPONS,
                      SUM(I.QTPRODVEND)                                                                                                                AS QTDE,
                      SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0) ), 2) - NVL (I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRVENDAS,
                      SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0))                                      AS VALOR_VENDIDO,
                      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                      '2'                                                                                                                              AS PERIODO,
                      V.NRORG
                    FROM VENDA V
                    JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                    AND V.NRORG     = I.NRORG
                    AND V.CDFILIAL  = I.CDFILIAL
                    AND V.CDCAIXA   = I.CDCAIXA
                    JOIN PARAVEND P
                    ON V.CDFILIAL = P.CDFILIAL
                    AND V.NRORG   = P.NRORG
                    JOIN FILIAL F
                    ON V.CDFILIAL       = F.CDFILIAL
                    AND V.NRORG         = F.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.NRORG         = :NRORG
                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                    AND INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                    AND ( TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(P.HRINI2DAYPART, 'HH24:MI:SS' ) AND TO_DATE(P.HRFIN2DAYPART, 'HH24:MI:SS' ) )
                    GROUP BY V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI2DAYPART,
                      P.HRFIN2DAYPART,
                      V.NRORG
                    UNION ALL
                    SELECT V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI3DAYPART,
                      P.HRFIN3DAYPART,
                      COUNT(DISTINCT V.CDFILIAL
                      || V.CDCAIXA
                      || V.NRSEQVENDA)                                                                                                                 AS NRCUPONS,
                      SUM(I.QTPRODVEND)                                                                                                                AS QTDE,
                      SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0) ), 2) - NVL (I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRVENDAS,
                      SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0))                                      AS VALOR_VENDIDO,
                      SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                      '3'                                                                                                                              AS PERIODO,
                      V.NRORG
                    FROM VENDA V
                    JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                    AND V.NRORG     = I.NRORG
                    AND V.CDFILIAL  = I.CDFILIAL
                    AND V.CDCAIXA   = I.CDCAIXA
                    JOIN PARAVEND P
                    ON V.CDFILIAL = P.CDFILIAL
                    AND V.NRORG   = P.NRORG
                    JOIN FILIAL F
                    ON V.CDFILIAL       = F.CDFILIAL
                    AND V.NRORG         = F.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.NRORG         = :NRORG
                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                    AND INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                    AND ( TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(P.HRINI3DAYPART, 'HH24:MI:SS' ) AND TO_DATE(P.HRFIN3DAYPART, 'HH24:MI:SS' ) )
                    GROUP BY V.CDFILIAL,
                      F.NMFILIAL,
                      P.HRINI3DAYPART,
                      P.HRFIN3DAYPART,
                      V.NRORG
                    UNION ALL
                    SELECT A.CDFILIAL,
                      A.NMFILIAL,
                      A.HRINI4DAYPART,
                      A.HRFIN4DAYPART,
                      SUM(A.NRCUPONS)      AS NRCUPONS,
                      SUM(A.QTDE)          AS QTDE,
                      SUM(A.VRVENDAS)      AS VRVENDAS,
                      SUM(A.VALOR_VENDIDO) AS VALOR_VENDIDO,
                      SUM(A.VRDESCONTO)    AS VRDESCONTO,
                      '4'                  AS PERIODO,
                      A.NRORG
                    FROM
                      (SELECT V.CDFILIAL,
                        F.NMFILIAL,
                        P.HRINI4DAYPART,
                        P.HRFIN4DAYPART,
                        COUNT(DISTINCT V.CDFILIAL
                        || V.CDCAIXA
                        || V.NRSEQVENDA)                                                                                                                 AS NRCUPONS,
                        SUM(I.QTPRODVEND)                                                                                                                AS QTDE,
                        SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0) ), 2) - NVL (I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRVENDAS,
                        SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0))                                      AS VALOR_VENDIDO,
                        SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                        V.NRORG
                      FROM VENDA V
                      JOIN ITEMVENDA I
                      ON V.NRSEQVENDA = I.NRSEQVENDA
                      AND V.NRORG     = I.NRORG
                      AND V.CDFILIAL  = I.CDFILIAL
                      AND V.CDCAIXA   = I.CDCAIXA
                      JOIN PARAVEND P
                      ON V.CDFILIAL = P.CDFILIAL
                      AND V.NRORG   = P.NRORG
                      JOIN FILIAL F
                      ON V.CDFILIAL       = F.CDFILIAL
                      AND V.NRORG         = F.NRORG
                      WHERE V.IDSITUVENDA = 'O'
                      AND V.NRORG         = :NRORG
                      AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                      AND INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                      AND ( TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(P.HRINI4DAYPART, 'HH24:MI:SS' )  AND TO_DATE(TO_CHAR('23:59:59'), 'HH24:MI:SS' ) )
                      
                      GROUP BY V.CDFILIAL,
                        F.NMFILIAL,
                        P.HRINI4DAYPART,
                        P.HRFIN4DAYPART,
                        V.NRORG
                      UNION ALL
                      SELECT V.CDFILIAL,
                        F.NMFILIAL,
                        P.HRINI4DAYPART,
                        P.HRFIN4DAYPART,
                        COUNT(DISTINCT V.CDFILIAL
                        || V.CDCAIXA
                        || V.NRSEQVENDA)                                                                                                                 AS NRCUPONS,
                        SUM(I.QTPRODVEND)                                                                                                                AS QTDE,
                        SUM(TRUNC(I.QTPRODVEND * ( NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0) ), 2) - NVL (I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRVENDAS,
                        SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND, 0))                                      AS VALOR_VENDIDO,
                        SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO,
                        V.NRORG
                      FROM VENDA V
                      JOIN ITEMVENDA I
                      ON V.NRSEQVENDA = I.NRSEQVENDA
                      AND V.NRORG     = I.NRORG
                      AND V.CDFILIAL  = I.CDFILIAL
                      AND V.CDCAIXA   = I.CDCAIXA
                      JOIN PARAVEND P
                      ON V.CDFILIAL = P.CDFILIAL
                      AND V.NRORG   = P.NRORG
                      JOIN FILIAL F
                      ON V.CDFILIAL       = F.CDFILIAL
                      AND V.NRORG         = F.NRORG
                      WHERE V.IDSITUVENDA = 'O'
                      AND V.NRORG         = :NRORG
                      AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                      AND INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                      AND ( TO_DATE(TO_CHAR(V.DTVENDA, 'HH24:MI:SS' ), 'HH24:MI:SS' ) BETWEEN TO_DATE(TO_CHAR('00:00:00'), 'HH24:MI:SS' ) AND TO_DATE(P.HRFIN4DAYPART, 'HH24:MI:SS' )  )
                      GROUP BY V.CDFILIAL,
                        F.NMFILIAL,
                        P.HRINI4DAYPART,
                        P.HRFIN4DAYPART,
                        V.NRORG
                      ) A
                    GROUP BY A.CDFILIAL,
                      A.NMFILIAL,
                      A.HRINI4DAYPART,
                      A.HRFIN4DAYPART,
                      A.NRORG
                    ORDER BY 1,
                      8";
              
              
              const GET_VALOR_TOTAL = "SELECT NVL(SUM(NVL(IT.VRACRITVEND,0))- SUM(NVL(V.VRREPIQUEVENDA,0)), 0) AS VALOR_TOTAL
                    FROM ITEMVENDA IT,
                        LOJA L,
                        VENDA V
                    WHERE IT.CDPRODUTO                = L.CDPRODTAXAENTR
                    AND IT.NRORG                      = L.NRORG
                    AND V.NRSEQVENDA                  = IT.NRSEQVENDA
                    AND V.CDCAIXA                     = IT.CDCAIXA
                    AND V.CDFILIAL                    = IT.CDFILIAL
                    AND V.NRORG                       = IT.NRORG
                    AND L.CDLOJA                      = V.CDLOJA
                    AND L.CDFILIAL                    = V.CDFILIAL
                    AND L.NRORG                       = V.NRORG
                    AND INSTR(:CDFILIAL, V.CDFILIAL)  > 0
                    AND L.IDTRATTAXAENTR              = 'P'
                    AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV'
                    AND IT.NRORG                      = :NRORG
                    AND V.IDSITUVENDA                 = 'O'
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                    GROUP BY V.CDFILIAL,
                    SUBSTR(V.IDORIGEMVENDA, 0, 3)";
	
}